<?php
/**
 * Sobak CMS 0.3
 * db class (db.class.php)
 * Copyright by Sobak (http://sobak.pl/) 2010-11
**/
class db {
    public function connect () {
        include ('config.php');
        try {
            $server = $cfg['db_server'];
            $db_name = $cfg['db_name'];

            $pdo = new PDO("mysql:host=$server;dbname=$db_name", $cfg['db_user'], $cfg['db_pass']);
            $pdo -> setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        }

        catch(PDOException $e) {
            echo '<b>Błąd:</b> Nieudane połącznie z bazą danych';
            logger::add_event ('1', __FILE__, __LINE__, $e->getMessage());
        }
    }

    public function query ($query) {
        try {
            return $pdo->query($query);
        }
        catch(PDOException $e) {
            echo '<b>Błąd:</b> Nieudane wykonanie zapytania';
            logger::add_event ('1', __FILE__, __LINE__, $e->getMessage());
        }
    }
    
    public function exec ($query) {
        try {
            $pdo->exec($query);
        }
        catch(PDOException $e) {
            echo '<b>Błąd:</b> Nieudane wykonanie zapytania';
            logger::add_event ('1', __FILE__, __LINE__, $e->getMessage());
        }
    }
}
?>